package Go;

import Go.strategy.*;

public class AtariGoMinMaxPlayer extends Player {

  public AtariGoMinMaxPlayer(int color, GoStrategy strategy) {
    super(color);
    this.strategy = strategy;
  }

  // override Player's initPlayer method
  public void initPlayer() {}

  // Methods declared in GoGameListener interface,
  // implemented by Player
  public void positionChanged(GoGameEvent goGameEvent) {}
  public void gameOver(GoGameEvent goGameEvent) {}

  // override Player's move method
  protected Move move(GoPosition goPosition) {
    Move nextMove;

    if ((nextMove = BasicAtariGoStrategy.tryBasicMove(goPosition)) == null)
      return strategy.chooseNextMove(goPosition);
    else
      return nextMove;
  }
}