package Go;

import java.util.Enumeration;

// a location on the goban: can be a stone or just an empty intersection
public class GobanLocation implements GoConstants{
  public GobanLocation(int State) {
    state = State;
    liberties = new ListOfLiberties();
  }

  public GobanLocation(GobanLocation location) {
    x = location.x;
    y = location.y;
    state = location.state;
    thePosition = location.thePosition;
    liberties = new ListOfLiberties();
  }

  //constructor
  public GobanLocation(int X, int Y, int State, GoPosition currentPosition) {
    x = X;
    y = Y;
    state = State;

    //System.out.println("[GobanLocation] Received handler to Position: " + currentPosition);
    thePosition = currentPosition;
    liberties = new ListOfLiberties();
  }

  //constructor
  public GobanLocation(Move theMove, GoPosition currentPosition) {
    x = theMove.x;
    y = theMove.y;
    state = theMove.color;

    //System.out.println("[GobanLocation] Received handler to Position: " + currentPosition);
    thePosition = currentPosition;
    liberties = new ListOfLiberties();
  }


  // set the group this stone belongs to
  public void setGroup(Group group) {this.group = group;}

  // set the group this stone belongs to
  public Group getGroup() {return this.group;}


  // overriding Object's comparing method
   public boolean equals(Object anObject) {
     if (anObject instanceof GobanLocation) {
       GobanLocation currentLocation = (GobanLocation)anObject;
       if ((this.x == currentLocation.x) &&
           (this.y == currentLocation.y))
         return true;
     }
     return false;
   }

  //public method used to compute a goban point's liberties
  public void computeLiberties() {
    // should create a new liberties list,
    // otherwise we get a NullPointerException in processLiberty

    //liberties = new ListOfLiberties(); // moved to connstructors


    //listOfNeighborEnemies = new ListOfGroups();

    ListOfLiberties listOfNeighbors = this.getNeighborsList();
    Enumeration e = listOfNeighbors.getElements();
    for (;e.hasMoreElements();) {
    	GobanLocation currentNeighbor = (GobanLocation)e.nextElement();
      processLiberty(currentNeighbor.x, currentNeighbor.y);
    }
  } // computeLiberties

  public String toString() {
  	return "(" + x + "," + y + ";" + state + ")";
  }

  public ListOfGroups getNeighborEnemies() {
    ListOfLiberties listOfNeighbors = this.getNeighborsList();
    ListOfGroups listOfEnemyGroups = new ListOfGroups();

    Enumeration e = listOfNeighbors.getElements();
    for (;e.hasMoreElements();) {
    	GobanLocation currentNeighbor = (GobanLocation)e.nextElement();
    	if (currentNeighbor.state != EMPTY  || currentNeighbor.state != this.state)
    		listOfEnemyGroups.add(currentNeighbor.getGroup());
    }

    return listOfEnemyGroups;

  } // getNeighborEnemies()

  private ListOfLiberties getNeighborsList() {
  	ListOfLiberties listOfNeighbors = new ListOfLiberties();

  	if (this.x > 0) {
      listOfNeighbors.add(thePosition.goban[this.x - 1][this.y]);
    }

    if (this.y > 0) {
      listOfNeighbors.add(thePosition.goban[this.x][this.y - 1]);
    }

    if (this.x < thePosition.getSize() - 1) {
      listOfNeighbors.add(thePosition.goban[this.x + 1][this.y]);
    }

    if (this.y < thePosition.getSize() - 1) {
      listOfNeighbors.add(thePosition.goban[this.x][this.y + 1]);
    }

    return listOfNeighbors;
  } // getNeighborList

  // private implementation method used in computeLiberties
  private void processLiberty(int currentX, int currentY) {
  	GobanLocation currentNeighbor = thePosition.goban[currentX][currentY];
    if (currentNeighbor.state == EMPTY)
      liberties.add(currentNeighbor);
      //liberties.add(new Move(currentX, currentY, GoConstants.EMPTY));
  } // processLiberty

  private GoPosition thePosition;

  // the group this stone belongs to (IF this is a stone)
  private Group group;

  public int x;
  public int y;

  //can be EMPTY, BLACK or WHITE
   public int state;

  // the list of liberties surrounding this location
  public ListOfLiberties liberties;

}