package Go.strategy;

public class GameTree implements GameTreeInterface {
  
  public GameTree(Object rootObject) {
    // create the first node, the root 
    this.root = new TreeNode(rootObject, null);
  } 

  public TreeNodeInterface getRoot() {
    return root;
  }

  public TreeNodeInterface getNextSiblingOf(TreeNodeInterface node) {
    return node.getParent().getChildNextTo(node);  
  }

  public TreeNodeInterface getFirstChildOf(TreeNodeInterface parentNode) {
    return parentNode.getFirstChild();
  }

  public TreeNodeInterface getParent(TreeNodeInterface node) {
    return node.getParent();
  }

  public boolean isLeaf(TreeNodeInterface node) {
    return node.isLeaf();
  }

  public void add_ChildTo(TreeNodeInterface child, 
                          TreeNodeInterface parent) {

    parent.addChild(child);
  }

  public void remove_ChildFrom(TreeNodeInterface child, 
                               TreeNodeInterface parent) {
    parent.removeChild(child);
  }

  protected TreeNodeInterface root; 
}