package Go.strategy;

import java.util.Vector;

public class TreeNode implements TreeNodeInterface {

  public TreeNode(Object nodeContent, TreeNodeInterface parentNode) {
    content = nodeContent; 
	  parent = parentNode;
    children = new Vector(); 
  }

  public Object getContent() {
    return content;  
  }

  public void setContent(Object newContent) {
    this.content = newContent;
  }

  public TreeNodeInterface getParent() {
    return parent;
  }
  public void setParent(TreeNodeInterface newParent) {
    this.parent = newParent;
  }

  public TreeNodeInterface getFirstChild() {
    return (TreeNodeInterface)(children.firstElement());
  }

  public Vector getChildren() {
    return children;
  }

  // returns the next element (child) in the children list
  public TreeNodeInterface getChildNextTo(TreeNodeInterface child) {
    int index = children.indexOf(child);
	 if ((index >= 0) && (index < children.size()))
 	   return (TreeNodeInterface)(children.elementAt(index));  
    else return null;
  }

  public boolean isLeaf() {
    return (children.size() < 1);
  }

  public void addChild(TreeNodeInterface child) {
    children.addElement(child);
	 child.setParent(this);
  }

  public void removeChild(TreeNodeInterface child) {
    children.removeElement(child);
  }

  protected Object content;
  protected TreeNodeInterface parent;
  protected Vector children;
}