//Author:       Sorin Gherman
//Description:  Your description

package Manager;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import Go.*;
import Goban.GobanView;

public class GameManagerFrame extends Frame implements ActionListener{
  MenuBar Menu = new MenuBar();
  Menu menu1 = new Menu();
  MenuItem menuItem1 = new MenuItem();
  Menu menu2 = new Menu();
  MenuItem menuItem2 = new MenuItem();

  MenuItem menuItem3 = new MenuItem();

  public GameManagerFrame() {
    System.out.println("GameManagerFrame constructor started");

    settingsDialog = new SettingsDialog(this,
                                        "Settings...",
                                        true);

    this.addActionListener(this);

    gameManager = new GameManager();
    this.getSettingsDialog().addActionListener(this);

    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

    Dimension frameSize = this.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    this.setVisible(true);

    settingsDialog.pack();
  }

  public Dimension getMinimumSize() {
    return new Dimension(224, 300);
  }

  public Dimension getPreferredSize() {
    return getMinimumSize();
  }

  public SettingsDialog getSettingsDialog() {
   return settingsDialog;
  }

  protected Vector listeners = new Vector();;

  public void addActionListener(ActionListener l) {
    listeners.addElement(l);
  }

  public void removeActionListener(ActionListener l) {
    listeners.removeElement(l);
  }


  public static void main(String[] args) {
    new GameManagerFrame();
  }

  private void jbInit() throws Exception {
    //this.setBackground(new Color(208, 189, 134));
    this.setSize(new Dimension(188, 303));
    this.setMenuBar(Menu);
    menu1.setLabel("Game");
    menuItem1.setLabel("Settings");
    menuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuSettings_actionPerformed(e);
      }
    });

    menu2.setLabel("Exit");
    menuItem2.setLabel("Quit");
    menuItem2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuExit_actionPerformed(e);
      }
    });

    /*menuItem3.setLabel("Start");
    menuItem3.setActionCommand("start");
    menuItem3.addActionListener(this);*/

    Menu.add(menu1);
    Menu.add(menu2);
    menu1.add(menuItem1);
    //menu1.add(menuItem3);
    menu2.add(menuItem2);

    panel3.setLayout(borderLayout2);
    panel2.setLayout(borderLayout1);

    btnFirstMove.setActionCommand(GameManagerConstants.FirstMove);
    //@btnFirstMove.addActionListener(thisListener);
    btnFirstMove.addActionListener(this);

    btnPrevMove.setActionCommand(GameManagerConstants.PrevMove);
    //@btnPrevMove.addActionListener(thisListener);
    btnPrevMove.addActionListener(this);

    btnNextMove.setActionCommand(GameManagerConstants.NextMove);
    //@btnNextMove.addActionListener(thisListener);
    btnNextMove.addActionListener(this);

    btnLastMove.setActionCommand(GameManagerConstants.LastMove);
    //@btnLastMove.addActionListener(thisListener);
    btnLastMove.addActionListener(this);

    /*this.add(panel1, BorderLayout.NORTH);
    panel1.add(btnFirstMove, null);
    panel1.add(btnPrevMove, null);
    panel1.add(btnNextMove, null);
    panel1.add(btnLastMove, null);*/ // not functiononal yet..

    this.add(panel2, BorderLayout.CENTER);

    /*this.add(panel3, BorderLayout.SOUTH);
    panel3.add(statusBar);*/

    gobanView = new GobanView(new GoPosition(GameManagerConstants.AtariGoTableSize));
    //gobanView.setBackground(new Color(208, 189, 134));
    statusBar.setText("Status bar");
    panel2.add(gobanView, BorderLayout.CENTER);
  }

  void menuSettings_actionPerformed(ActionEvent e) {
    //Center the dialog window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = settingsDialog.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    settingsDialog.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

    settingsDialog.setVisible(true);
  }

  void menuExit_actionPerformed(ActionEvent e) {
    dispose();
    System.exit(0);
  }

  // ActionListener method
  public void actionPerformed(ActionEvent e) {
    if (e.getActionCommand().equals("ok")) {
      SettingsDialog settingsDialog = this.getSettingsDialog();
      game = gameManager.createGame(Integer.parseInt(settingsDialog.edtBoardSize.getText()),
                             settingsDialog.choiceBlackPlayerType.getSelectedItem(),
                             settingsDialog.choiceWhitePlayerType.getSelectedItem());

      if (gobanView != null)
        panel2.remove(gobanView);

      gobanView = new GobanView(game.goPosition);
      gameManager.registerGobanView(gobanView);
      game.addListener(gobanView);

      panel2.add(gobanView, BorderLayout.CENTER);
      //this.pack();
      //this.setSize(gobanView.getSize().width, this.getSize().height);
      this.setVisible(true);

      StartGameThread startGameThread = new StartGameThread();
      startGameThread.start();
    }
    else if (e.getActionCommand().equals("switch")) {}
    /*else if (e.getActionCommand().equals("start")) {
      StartGameThread startGameThread = new StartGameThread();
      startGameThread.start();
    } */

    else if (e.getActionCommand().equals("Settings")) {
      menuSettings_actionPerformed(e);
    }
    else if (e.getActionCommand().equals(GameManagerConstants.FirstMove)) {
      this.statusBar.setText("Go to beginning");
    }
    else if (e.getActionCommand().equals(GameManagerConstants.PrevMove)) {
      this.statusBar.setText("Go to previous move");
    }
    else if (e.getActionCommand().equals(GameManagerConstants.NextMove)) {
      this.statusBar.setText("Go to next move");
    }
    else if (e.getActionCommand().equals(GameManagerConstants.LastMove)) {
      this.statusBar.setText("Go to last move");
    }
  }

  class StartGameThread extends Thread {
    public void run() {
      game.playGame();
    }
  }

  private GameManager gameManager = null;
  private GoGame game = null;
  private GobanView gobanView = null;

  private Panel panel1 = new Panel();
  Button btnFirstMove = new Button("|<<");
  Button btnPrevMove = new Button("<");
  Button btnNextMove = new Button(">");
  Button btnLastMove = new Button(">>|");

  SettingsDialog settingsDialog = null;

  //StatusBar statusBar = new StatusBar();
  Label statusBar = new Label();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
}

